From 546067eee44faf602796d3e34410ba8561a26a8d Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:11 +0000
Subject: [PATCH 739/1001] Improve API doc crossreferences


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index a4cafba..1ec88bc 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -26,8 +26,8 @@ In order to be valid, a widget must:
 - inherit from the :py:class:`hubs.widgets.base.Widget` class,
 - have a valid :py:attr:`~hubs.widgets.base.Widget.name` attribute,
 - have a valid :py:attr:`~hubs.widgets.base.Widget.position` attribute,
-- contain at least one view named "``root``", registered for the "``/``" URL.
-  See the description of widget views below for details.
+- contain at least one widget view named "``root``", registered for the "``/``"
+  URL.
 
 A widget view is a class which inherits from the
 :py:class:`hubs.widgets.view.WidgetView` class.  A widget can have one or more
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 824e34d..70dbc9c 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -27,9 +27,10 @@ class Widget(object):
             will appear in some URLs, so be careful to only use simple,
             URL-compatible characters.
         position (str): The position of the widget in the rendered page. It
-            should be one of the following values: 'left', 'right', or 'both'.
+            should be one of the following values: ``left``, ``right``, or
+            ``both``.
         arguments (list): A list of dictionaries that describe a widget's
-            configuration. See `hubs.widgets.base.Argument`.
+            configuration. See :py:class:`hubs.widgets.base.Argument`.
     """
 
     name = None
@@ -40,7 +41,11 @@ class Widget(object):
         self._template_environment = None
 
     def validate(self):
-        """Ensure that the widget has the bits it needs."""
+        """
+        Ensure that the widget has the bits it needs.
+
+        Raises: AttributeError
+        """
         if self.name is None:
             raise AttributeError('Widgets must have a "name" attribute')
         if not re.match('^[\w_.-]+$', self.name):
@@ -89,7 +94,7 @@ class Widget(object):
 
     def _get_local_subclasses(self, parent_class):
         """
-        Returns the subclasses of the `parent_class` defined in this widget's
+        Returns the subclasses of the ``parent_class`` defined in this widget's
         Python module.
         """
         result = []
@@ -111,7 +116,7 @@ class Widget(object):
         """
         Returns:
             dict: A dictionary of the widget-specific views, indexed by their
-                `name` attribute.
+                :py:attr:`~hubs.widgets.view.WidgetView.name` attribute.
         """
         return dict([
             (view.name, view) for view in
diff --git a/hubs/widgets/caching.py b/hubs/widgets/caching.py
index 2eded91..c8a56e8 100644
--- a/hubs/widgets/caching.py
+++ b/hubs/widgets/caching.py
@@ -1,7 +1,7 @@
 """
 Attributes:
     cache (dogpile.cache.region.CacheRegion): The cache where function results
-        will be stored. It is configured with the `fedora-hubs.cache` key in
+        will be stored. It is configured with the ``fedora-hubs.cache`` key in
         fedmsg configuration.
 """
 from __future__ import unicode_literals
@@ -40,17 +40,18 @@ class CachedFunction(object):
 
     To use this class, you must subclass it and implement a couple methods.
     It is instantiated by passing a widget instance (database record) as only
-    argument, which lets it access the `.config` property and act accordingly.
+    argument, which lets it access the :py:attr:`~hubs.models.Widget.config`
+    property and act accordingly.
 
-    You must implement the `execute()` method, which must return a
+    You must implement the :py:meth:`.execute` method, which must return a
     JSON-serializable value.
 
-    You must also implement the `should_invalidate()` method, which takes the
-    bus message as only argument, and returns `True` if the cache should be
-    rebuild, `False` otherwise.
+    You must also implement the :py:meth:`.should_invalidate` method, which
+    takes the bus message as only argument, and returns ``True`` if the cache
+    should be rebuild, ``False`` otherwise.
 
     To call the function, instanciate the class and execute it. You may also
-    call the `.get_data()` method.
+    call the :py:meth:`.get_data` method.
 
     Args:
         instance (hubs.models.Widget): The widget instance.
@@ -111,7 +112,7 @@ class CachedFunction(object):
             message (dict): The recieved bus message.
 
         Returns:
-            bool: If `True`, the cache will be rebuilt.
+            bool: If ``True``, the cache will be rebuilt.
         """
         # if not self._pass_filter(message):
         #     return False
@@ -119,7 +120,8 @@ class CachedFunction(object):
 
     def is_cached(self):
         """
-        Return a boolean indicating if the function's result is currently in the cache.
+        Return a boolean indicating if the function's result is currently in
+        the cache.
 
         Returns:
             bool: Whether the cache currently contains the function result.
diff --git a/hubs/widgets/registry.py b/hubs/widgets/registry.py
index db463b3..109e69a 100644
--- a/hubs/widgets/registry.py
+++ b/hubs/widgets/registry.py
@@ -33,7 +33,7 @@ class WidgetRegistry(UserDict):
 
         Args:
             widget_path (str): Python path to the subclass of
-                `hubs.widgets.base.Widget`.
+                :py:class:`hubs.widgets.base.Widget`.
         """
         mod_path, _, cls_name = widget_path.rpartition('.')
         mod = import_module(mod_path)
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index 05a633a..19ff77c 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -9,30 +9,32 @@ class WidgetView(View):
 
     You must subclass this class to use it in your view:
 
-    - the `name` attribute must be defined
-    - the `template_name` attribute must be defined, or the `get_template()`
-      method must be implemented
-    - the `get_context()` method must be implemented
+    - the :py:attr:`.name` attribute must be defined
+    - the :py:attr:`.template_name` attribute must be defined, or the
+      :py:meth:`.get_template` method must be implemented
+    - the :py:meth:`.get_context` method must be implemented
 
-    Every widget must have a view with the name "`root`" registered to `['/']`,
-    which will be the main entry point for the widget.
+    Every widget must have a view with the name "``root``" registered to
+    ``['/']``, which will be the main entry point for the widget.
 
     The resulting endpoint will be composed using the widget name and the view
-    name as `<widget_name>_<view_name>`, for example `meetings_root`.
-    Remember that when you want to reverse the URL with `url_for`.
+    name as ``<widget_name>_<view_name>``, for example ``meetings_root``.
+    Remember that when you want to reverse the URL with :py:meth:`url_for`.
 
     When reversing the URL, you need to pass the ``hub`` and ``idx`` kwargs,
-    which are respectively the hub name (`Hub.name`) and the widget instance
-    (the database record) primary key (`Widget.idx`).
+    which are respectively the hub name (:py:attr:`hubs.models.Hub.name`) and
+    the widget instance (the database record) primary key
+    (:py:attr:`hubs.models.Widget.idx`).
 
     Attributes:
         name (str): The view name. It will be used to compose the URL endpoint,
-            following the "`<widget.name>_<view.name>`" convention.
+            following the "``<widget.name>_<view.name>``" convention.
         url_rules (list): A list of URL rules that this view must be registered
-            for (like the `rule` parameter of Flask's `add_url_rule()`).
+            for (like the ``rule`` parameter of Flask's
+            :py:meth:`add_url_rule`).
         template_name (str): The template name to use for this view. It will be
-            looked for in the widget's `templates` subdirectory first, and
-            then in the global `hubs/widgets/templates/` directory.
+            looked for in the widget's ``templates`` subdirectory first, and
+            then in the global ``hubs/widgets/templates/`` directory.
 
     This class is Flask-specific. If another framework were to be switched to,
     it would have to be re-implemented.
@@ -62,8 +64,8 @@ class WidgetView(View):
 
     def get_template(self):
         """
-        Return the template object, looking for `template_name` in the widget's
-        template environment.
+        Return the template object, looking for :py:attr:`template_name` in the
+        widget's template environment.
         """
         if self.template_name is None:
             return NotImplementedError
@@ -89,8 +91,8 @@ class WidgetView(View):
 
     def dispatch_request(self, *args, **kwargs):
         """
-        The `dispatch_request` method that subclasses of `flask.views.View`
-        must implement. It binds the other methods together.
+        The method that subclasses of :py:class:`flask.views.View` must
+        implement. It binds the other methods together.
         """
         instance = self._get_instance(*args, **kwargs)
         context = self.get_context(instance, *args, **kwargs)

